ALTER PROCEDURE "dba"."ea_korrigeeri_koik"( in a_par char(40),in a_id1 integer, in a_s1 char(20) )
BEGIN
  declare ll_pos integer;
  set ll_pos=Locate(a_par,'_NULL');
  if ll_pos>1 then
    set a_id1=null;
    set a_s1=null;
    set a_par=Left(a_par,ll_pos-1);
  end if;
  case a_par
    when 'KandedKorrastadaMeetmed' then
      update "ea_kanne" left outer join "gl_selectall" on "ea_kanne"."id"="gl_selectall"."id1" and "ea_kanne"."aasta"="gl_selectall"."id2"
        set "ea_kanne"."meetnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaKuluobjektid' then
      update "ea_kanne" left outer join "gl_selectall" on "ea_kanne"."id"="gl_selectall"."id1" and "ea_kanne"."aasta"="gl_selectall"."id2"
        set "ea_kanne"."kulnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaTegevusalad' then
      update "ea_kanne" left outer join "gl_selectall" on "ea_kanne"."id"="gl_selectall"."id1" and "ea_kanne"."aasta"="gl_selectall"."id2"
        set "ea_kanne"."talnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaKululiigid' then
      update "ea_kanne" left outer join "gl_selectall" on "ea_kanne"."id"="gl_selectall"."id1" and "ea_kanne"."aasta"="gl_selectall"."id2"
        set "ea_kanne"."artnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaTululiigid' then
      update "ea_kanne" left outer join "gl_selectall" on "ea_kanne"."id"="gl_selectall"."id1" and "ea_kanne"."aasta"="gl_selectall"."id2"
        set "ea_kanne"."tulnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaProjektid' then
      update "ea_kanne" left outer join "gl_selectall" on "ea_kanne"."id"="gl_selectall"."id1" and "ea_kanne"."aasta"="gl_selectall"."id2"
        set "ea_kanne"."objectnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaOsakonnad' then
      update "ea_kanne" left outer join "gl_selectall" on "ea_kanne"."id"="gl_selectall"."id1" and "ea_kanne"."aasta"="gl_selectall"."id2"
        set "ea_kanne"."osaknr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaSubjektid' then
      update "ea_kanne" left outer join "gl_selectall" on "ea_kanne"."id"="gl_selectall"."id1" and "ea_kanne"."aasta"="gl_selectall"."id2"
        set "ea_kanne"."subjectnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaTegevussuunad' then
      update "ea_kanne" left outer join "gl_selectall" on "ea_kanne"."id"="gl_selectall"."id1" and "ea_kanne"."aasta"="gl_selectall"."id2"
        set "ea_kanne"."suundnr"=a_id1 where "gl_selectall"."id1" is not null
    when 'KandedKorrastadaTaotlused' then
      update "ea_kanne" left outer join "gl_selectall" on "ea_kanne"."id"="gl_selectall"."id1" and "ea_kanne"."aasta"="gl_selectall"."id2"
        set "ea_kanne"."taotnr"=a_id1 where "gl_selectall"."id1" is not null
  end case;
END